/**
* DevExtreme (keyboard_navigation/dom.js)
* Version: 22.2.4 (build 23079-0308)
* Build date: Mon Mar 20 2023
*
* Copyright (c) 2012 - 2023 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import { ATTRIBUTES } from './const';

const isDragCell = ($cell) => $cell.attr(ATTRIBUTES.dragCell) !== undefined;

const getCellToFocus = ($cellElements, columnIndex) => $cellElements
    .filter(`[${ATTRIBUTES.ariaColIndex}="${columnIndex + 1}"]:not([${ATTRIBUTES.dragCell}])`)
    .first();

export const GridCoreKeyboardNavigationDom = {
    isDragCell,
    getCellToFocus,
};
